//
//																				//
//																				//
//					Copyright PennyWise Software, 1994.							//
//																				//
//			Part of the PennyWise Software Application Framework				//
//																				//
//																				//
//			CoreAppleEvents.c		Written by Peter Kaplan						//
//																				//
//																				//
//
#include <AppleEvents.h>
#include "CoreAppleEvents.h"
#include <PWFramework.h>
//
// local prototypes
static OSErr MyGotRequiredParams (AppleEvent *theAppleEvent);

pascal OSErr  MyHandleODoc (AppleEvent *theAppleEvent, AppleEvent* reply, long handlerRefCon);
pascal OSErr  MyHandlePDoc (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefCon);
pascal OSErr  MyHandleOApp (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefCon);
pascal OSErr  MyHandleQApp (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefCon);

//
pascal OSErr  MyHandleODoc (AppleEvent *theAppleEvent, AppleEvent* reply, long handlerRefCon)
{
FSSpec		myFSS;
AEDescList	docList;
OSErr		err;
long		index,itemsInList;
Size		actualSize;
AEKeyword	keywd;
DescType	returnedType;

	// get the direct parameter--a descriptor list--and put it into a docList
	err = AEGetParamDesc (theAppleEvent, keyDirectObject, typeAEList,
			&docList);
	if (err)
			return err;

	// check for missing parameters
	err = MyGotRequiredParams (theAppleEvent);
	if (err)
			return err;

	// count the number of descriptor records in the list
	err = AECountItems (&docList, &itemsInList);

	// now get each descriptor record from the list, coerce the returned
	// data to an FSSpec record, and open the associated file
	for (index = 1; index <= itemsInList; index++) {

			err = AEGetNthPtr (&docList, index, typeFSS, &keywd,
							&returnedType, (Ptr) &myFSS, sizeof(myFSS), &actualSize);
			if (err)
					return err;

			// here I have the file
	}

	err = AEDisposeDesc (&docList);
	return noErr;
}
//
pascal OSErr  MyHandlePDoc (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefCon)
{
FSSpec		myFSS;
AEDescList	docList;
OSErr		err;
long		index,
			itemsInList;
Size		actualSize;
AEKeyword	keywd;
DescType	returnedType;

	// get the direct parameter--a descriptor list--and put it into a docList
	err = AEGetParamDesc (theAppleEvent, keyDirectObject, typeAEList,
									&docList);
	if (err)
			return err;

	// check for missing parameters
	err = MyGotRequiredParams (theAppleEvent);
	if (err)
			return err;

	// count the number of descriptor records in the list
	err = AECountItems (&docList, &itemsInList);

	// now get each descriptor record from the list, coerce the returned
	// data to an FSSpec record, and open the associated file
	for (index = 1; index <= itemsInList; index++) {

			err = AEGetNthPtr (&docList, index, typeFSS, &keywd,
							&returnedType, (Ptr) &myFSS, sizeof(myFSS), &actualSize);
			if (err)
					return err;

			// Here I Have the file
	}

	err = AEDisposeDesc (&docList);
	return noErr;
}
//
pascal OSErr  MyHandleOApp (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefCon)
{
return noErr;
}
//
pascal OSErr  MyHandleQApp (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefCon)
{
PWQuitApplication();
return noErr;
}
//
OSErr MyGotRequiredParams (AppleEvent *theAppleEvent)
{
DescType	returnedType;
Size		actualSize;
OSErr		err;

	err = AEGetAttributePtr (theAppleEvent, keyMissedKeywordAttr,
									typeWildCard, &returnedType, nil, 0,
									&actualSize);
	if (err == errAEDescNotFound)	// you got all the required parameters
			return noErr;
	else if (!err)			// you missed a required parameter
			return errAEEventNotHandled;
	else					// the call to AEGetAttributePtr failed
			return err;
}
//
void InitOurAppleEvents()
{
	// Install AppleEvents
	AEInstallEventHandler (kCoreEventClass, kAEOpenDocuments, 	(ProcPtr)MyHandleODoc,0, FALSE);
	AEInstallEventHandler (kCoreEventClass, kAEOpenApplication,	(ProcPtr)MyHandleOApp,0, FALSE);
	AEInstallEventHandler (kCoreEventClass, kAEPrintDocuments,	(ProcPtr)MyHandlePDoc,0, FALSE);
	AEInstallEventHandler (kCoreEventClass, kAEQuitApplication,	(ProcPtr)MyHandleQApp,0, FALSE);
}
