//
//																				//
//																				//
//					Copyright PennyWise Software, 1994.							//
//																				//
//			Part of the PennyWise Software Application Framework				//
//																				//
//																				//
//			InitApplication.c		Written by Peter Kaplan						//
//																				//
//																				//
//
// Local Includes
#include "CoreAppleEvents.h"
#include "DefaultHandlers.h"
#include "HandleMenus.h"
#include "InitApplication.h"
//
// Added for PennyView
#include <Movies.h>
#include "MovieWindow.h"
#include "PictWindow.h"
#include "TextWindow.h"
//
void InitApplication()
{
Rect	boundsRect;

	// Set up the menus
	InitOurMenus();
	
	// Set up the AppleEvents
	InitOurAppleEvents();
	
	EnterMovies();					// Added for PennyView 
	
	// Set up the default handlers
	InitDefaultHandlers();

	// Here is where you will add the handlers
	InitMovieWindowHandlers();		// Added for PennyView
	InitPictWindowHandlers();		// Added for PennyView
	InitTextWindowHandlers();		// Added for PennyView
}
//
void InitOurMenus()
{
	ClearMenuBar();

	gMenuApple = GetMenu(kMENU_ID_APPLE);  						
	InsertMenu (gMenuApple,0);
	AddResMenu(gMenuApple,'DRVR');
	
	gMenuFile = GetMenu(kMENU_ID_FILE);
	InsertMenu (gMenuFile,0);

	gMenuEdit = GetMenu(kMENU_ID_EDIT);
	InsertMenu (gMenuEdit,0);

	DrawMenuBar();
}
